<?php

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**

*

* @version $Id: null.php 1336 2008-03-31 17:06:23Z soeren_nb $

* @package VirtueMart

* @subpackage Log

* @copyright Copyright (C) 2004-2008 soeren - All rights reserved.

* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php

* VirtueMart is free software. This version may have been modified pursuant

* to the GNU General Public License, and as distributed it includes or

* is derivative of works licensed under the GNU General Public License or

* other free or open source software licenses.

* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.

*

* http://virtuemart.net

*/



/**

 * $Header$

 *

 * @version $ Revision: 1.4 $

 * @package Log

 */



/**

 * The vmLog_null class is a concrete implementation of the Log:: abstract

 * class.  It simply consumes log events.

 *

 * @author  Jon Parise <jon@php.net>

 * @since   Log 1.8.2

 * @package Log

 *

 * @example null.php    Using the null handler.

 */

class vmLog_null extends vmLog

{

    /**

     * Constructs a new vmLog_null object.

     *

     * @param string $name     Ignored.

     * @param string $ident    The identity string.

     * @param array  $conf     The configuration array.

     * @param int    $level    Log messages up to and including this level.

     * @access public

     */

    function vmLog_null($name, $ident = '', $conf = array(),

					  $level = PEAR_LOG_DEBUG)

    {

        $this->_id = md5(microtime());

        $this->_ident = $ident;

        $this->_mask = vmLog::UPTO($level);

    }



    /**

     * Simply consumes the log event.  The message will still be passed

     * along to any Log_observer instances that are observing this Log.

     *

     * @param mixed  $message    String or object containing the message to log.

     * @param string $priority The priority of the message.  Valid

     *                  values are: PEAR_LOG_EMERG, PEAR_LOG_ALERT,

     *                  PEAR_LOG_CRIT, PEAR_LOG_ERR, PEAR_LOG_WARNING,

     *                  PEAR_LOG_NOTICE, PEAR_LOG_INFO, and PEAR_LOG_DEBUG.

     * @return boolean  True on success or false on failure.

     * @access public

     */

    function log($message, $priority = null)

    {

        /* If a priority hasn't been specified, use the default value. */

        if ($priority === null) {

            $priority = $this->_priority;

        }



        /* Abort early if the priority is above the maximum logging level. */

        if (!$this->_isMasked($priority)) {

            return false;

        }



        $this->_announce(array('priority' => $priority, 'message' => $message));



        return true;

    }



}

